Attribute VB_Name = "GoriPrt"
Option Explicit

Public PRT As Printer

' tHgV[gJbg
Public Const fontA As String = "Arial"
Public Const fontPG As String = "lr oSVbN"
Public Const fontG As String = "lr SVbN"
Public Const fontPM As String = "lr o"
Public Const fontM As String = "lr "
Public Const fontSK As String = "HG-PRO"
Public Const fontUI As String = "MS UI Gothic"

' @(f)
'
' @\      : ݒ
'
'
Public Sub gwPrinterSetup()
    With PRT
        .DrawWidth = 1
        .FontTransparent = False
        .FillStyle = 0
        .Font.name = fontA
        .FontName = fontA
        .Font.Size = 4
        
        PRT.Print " "
        .CurrentX = 0
        .CurrentY = 0

        .FillStyle = vbFSTransparent
        .DrawMode = vbBlackness
        .DrawStyle = vbSolid
        .FontTransparent = True
    End With
End Sub

' @(f)
'
' @\      : zu@\t Printer.Print
'
'     : ARG1 - wWP
'             ARG2 - wWQ
'             ARG3 - xW
'             ARG4 - \
'             ARG5 - wx\ʒu
'
' @\  : ɂ鉡ʒuPrintł
'
' l      : 5 ̃IvVɂĂ
'             0: 1:E 2: 3:
'             +10:xWl
'             łB
'
Public Sub gwPriPri(ByVal x1 As Single, ByVal x2 As Single, ByVal Y As Single, ByVal s As String, ByVal bs As Integer)
    If Len(s) = 0 Then Exit Sub
    With PRT
        If bs < 10 Then
            .CurrentY = Y
        Else
            .CurrentY = Y - PRT.TextHeight(s)
            bs = bs - 10
        End If
        Select Case bs
            Case 0: .CurrentX = x1
            Case 1: .CurrentX = x2 - .TextWidth(s)
            Case 2: .CurrentX = (x1 + x2 - .TextWidth(s)) / 2
            Case 3
                Dim i As Integer, l As Integer
                Dim d As Single

                l = Len(s)
                If l = 1 Then
                    .CurrentX = (x1 + x2 - .TextWidth(s)) / 2
                Else
                    d = (x2 - x1 - .TextWidth(s)) / (l - 1)
                    .CurrentX = x1 - d
                    For i = 1 To l
                        .CurrentX = .CurrentX + d
                        PRT.Print Mid$(s, i, 1);
                    Next
                    Exit Sub
                End If
        End Select
    End With
    PRT.Print s;
End Sub

' @(f)
'
' @\      : zu@\t Printer.Print cʒu
'
'     : ARG1 - wWP
'             ARG2 - wWQ
'             ARG3 - xWP
'             ARG4 - xWQ
'             ARG5 - \
'
' @\  : ɂʒuPrintłB
'
' l      : wW͏ɒAxW͏㉺󂯂B
'
Public Sub gwPriY(ByVal x1 As Single, ByVal x2 As Single, ByVal y1 As Single, ByVal y2 As Single, ByVal s As String)
    Dim i As Integer, l As Integer
    Dim d As Single, DD As Single
    
    If Len(s) = 0 Then Exit Sub
    With PRT
        l = Len(s)
        DD = .TextHeight(s)
        If l = 1 Then
            .CurrentX = (x1 + x2 - .TextWidth(s)) / 2
            .CurrentY = (y1 + y2 - DD) / 2
            PRT.Print s;
            Exit Sub
        End If
        
        d = (y2 - y1 - DD * l) / (l + 1)
        .CurrentY = y1 - DD
        For i = 1 To l
            .CurrentX = (x1 + x2 - .TextWidth(Mid$(s, i, 1))) / 2
            .CurrentY = .CurrentY + d + DD
            PRT.Print Mid$(s, i, 1);
        Next
    End With
End Sub

' @(f)
'
' @\      : cEƂzu@\t Printer.Print
'
'     : ARG1 - wWP
'             ARG2 - wWQ
'             ARG3 - xWP
'             ARG4 - xWQ
'             ARG5 - \
'             ARG6 - wx\ʒu
'
' @\  : ɂcʒuPrintł
'
' l      : 6 ̃IvVɂĂ
'             w  0: + 1:E + 2: + 3:i 0.5 ␳j
'             x  0:l +10:l +20:
'             łB
'
Public Sub gwPriPriXY(ByVal x1 As Single, ByVal x2 As Single, ByVal y1 As Single, ByVal y2 As Single, ByVal s As String, ByVal bs As Integer)
    If s = vbNullString Then Exit Sub
    With PRT
        Select Case bs \ 10
            Case 0: .CurrentY = y1
            Case 1: .CurrentY = y2 - PRT.TextHeight(s)
            Case 2: .CurrentY = (y1 + y2 - .TextHeight(s)) / 2
        End Select
        Select Case bs Mod 10
            Case 0: .CurrentX = x1
            Case 1: .CurrentX = x2 - .TextWidth(s)
            Case 2: .CurrentX = (x1 + x2 - .TextWidth(s)) / 2
            Case 3
                Dim i As Integer, l As Integer
                Dim d As Single

                l = Len(s)
                If l = 1 Then
                    .CurrentX = (x1 + x2 - .TextWidth(s)) / 2
                Else
                    d = (x2 - x1 - .TextWidth(s) - 1) / (l - 1)
                    .CurrentX = x1 + 0.5 - d
                    For i = 1 To l
                        .CurrentX = .CurrentX + d
                        PRT.Print Mid$(s, i, 1);
                    Next
                    Exit Sub
                End If
        End Select
    End With
    PRT.Print s;
End Sub

' @(f)
'
' @\      : tHgw
'
'     : ARG1 - tHg
'             ARG2 - TCY
'             ARG3 - Bold
'             ARG4 - Italic
'             ARG5 - Underline
'             ARG6 - StrikeThrough
'
' l      : PRT.Fontɑ΂ĐݒBȗڂ͕ێ܂B
'
Public Sub gwPrtF(Optional name As String = vbNullString, Optional Size As Integer = 0, Optional Bold As Integer = 1, Optional Italic As Integer = 1, Optional Underline As Integer = 1, Optional StrikeThrough As Integer = 1)
    With PRT.Font
        If name <> vbNullString Then .name = name
        If Size <> 0 Then .Size = Size
        If Bold <> 1 Then .Bold = Bold
        If Italic <> 1 Then .Italic = Italic
        If Underline <> 1 Then .Underline = Underline
        If StrikeThrough <> 1 Then .StrikeThrough = StrikeThrough
    End With
    PRT.FontName = PRT.Font.name
End Sub

